Index: /trunk/src/VBox/Main/win32/VBoxC.rc
===================================================================
--- /trunk/src/VBox/Main/win32/VBoxC.rc	(revision 8202)
+++ /trunk/src/VBox/Main/win32/VBoxC.rc	(revision 8203)
@@ -41,6 +41,6 @@
     BLOCK "040904E4" // Lang=US English, CharSet=Windows Multilingual
     BEGIN
-    VALUE "CompanyName",     "innotek GmbH\0"
-    VALUE "FileDescription", "innotek VirtualBox Interface\0"
+    VALUE "CompanyName",     "Sun Microsystems, Inc.\0"
+    VALUE "FileDescription", "Sun xVM VirtualBox Interface\0"
     VALUE "FileVersion",     "1.0.000\0"
     VALUE "InternalName",    "VBOXC\0"
@@ -48,5 +48,5 @@
     VALUE "LegalTrademarks", "\0"
     VALUE "OriginalFilename","VBOXC.DLL\0"
-    VALUE "ProductName",     "innotek VirtualBox\0"
+    VALUE "ProductName",     "Sun xVM VirtualBox\0"
     VALUE "ProductVersion",  "1.0.000\0"
 
Index: /trunk/src/VBox/Main/win32/VBoxSVC.rc
===================================================================
--- /trunk/src/VBox/Main/win32/VBoxSVC.rc	(revision 8202)
+++ /trunk/src/VBox/Main/win32/VBoxSVC.rc	(revision 8203)
@@ -41,6 +41,6 @@
     BLOCK "040904E4" // Lang=US English, CharSet=Windows Multilingual
     BEGIN
-    VALUE "CompanyName",     "innotek GmbH\0"
-    VALUE "FileDescription", "innotek VirtualBox Interface\0"
+    VALUE "CompanyName",     "Sun Microsystems, Inc.\0"
+    VALUE "FileDescription", "Sun xVM VirtualBox Interface\0"
     VALUE "FileVersion",     "1.0.000\0"
     VALUE "InternalName",    "VBOXSVC\0"
@@ -48,5 +48,5 @@
     VALUE "LegalTrademarks", "\0"
     VALUE "OriginalFilename","VBOXSVC.EXE\0"
-    VALUE "ProductName",     "innotek VirtualBox\0"
+    VALUE "ProductName",     "Sun xVM VirtualBox\0"
     VALUE "ProductVersion",  "1.0.000\0"
 
Index: /trunk/src/VBox/Main/xml/VirtualBox-settings-common.xsd
===================================================================
--- /trunk/src/VBox/Main/xml/VirtualBox-settings-common.xsd	(revision 8202)
+++ /trunk/src/VBox/Main/xml/VirtualBox-settings-common.xsd	(revision 8203)
@@ -4,5 +4,5 @@
  *  :folding=explicit:collapseFolds=1:
  *
- *  innotek VirtualBox Settings Schema
+ *  Sun xVM VirtualBox Settings Schema
  *  Common definitions
 
@@ -32,6 +32,6 @@
 <xsd:annotation>
   <xsd:documentation xml:lang="en">
-    innotek VirtualBox Settings Schema (common definitions).
-    Copyright (c) 2004-2007 innotek GmbH.
+    Sun xVM VirtualBox Settings Schema (common definitions).
+    Copyright (c) 2004-2007 Sun Microsystems, Inc.
   </xsd:documentation>
 </xsd:annotation>
Index: /trunk/src/VBox/Main/xml/VirtualBox-settings-freebsd.xsd
===================================================================
--- /trunk/src/VBox/Main/xml/VirtualBox-settings-freebsd.xsd	(revision 8202)
+++ /trunk/src/VBox/Main/xml/VirtualBox-settings-freebsd.xsd	(revision 8203)
@@ -4,5 +4,5 @@
  *  :folding=explicit:collapseFolds=1:
  *
- *  innotek VirtualBox Settings Schema Version 1.0-freebsd
+ *  Sun xVM VirtualBox Settings Schema Version 1.0-freebsd
 
      Copyright (C) 2004-2008 Sun Microsystems, Inc.
@@ -31,6 +31,6 @@
 <xsd:annotation>
   <xsd:documentation xml:lang="en">
-    innotek VirtualBox Settings Schema (freebsd).
-    Copyright (c) 2004-2008 innotek GmbH.
+    Sun xVM VirtualBox Settings Schema (freebsd).
+    Copyright (c) 2004-2008 Sun Microsystems, Inc.
   </xsd:documentation>
 </xsd:annotation>
Index: /trunk/src/VBox/Main/xml/VirtualBox-settings-linux.xsd
===================================================================
--- /trunk/src/VBox/Main/xml/VirtualBox-settings-linux.xsd	(revision 8202)
+++ /trunk/src/VBox/Main/xml/VirtualBox-settings-linux.xsd	(revision 8203)
@@ -4,5 +4,5 @@
  *  :folding=explicit:collapseFolds=1:
  *
- *  innotek VirtualBox Settings Schema Version 1.0-linux
+ *  Sun xVM VirtualBox Settings Schema Version 1.0-linux
 
      Copyright (C) 2004-2008 Sun Microsystems, Inc.
@@ -31,6 +31,6 @@
 <xsd:annotation>
   <xsd:documentation xml:lang="en">
-    innotek VirtualBox Settings Schema (linux).
-    Copyright (c) 2004-2008 innotek GmbH.
+    Sun xVM VirtualBox Settings Schema (linux).
+    Copyright (c) 2004-2008 Sun Microsystems, Inc.
   </xsd:documentation>
 </xsd:annotation>
Index: /trunk/src/VBox/Main/xml/VirtualBox-settings-macosx.xsd
===================================================================
--- /trunk/src/VBox/Main/xml/VirtualBox-settings-macosx.xsd	(revision 8202)
+++ /trunk/src/VBox/Main/xml/VirtualBox-settings-macosx.xsd	(revision 8203)
@@ -4,5 +4,5 @@
  *  :folding=explicit:collapseFolds=1:
  *
- *  innotek VirtualBox Settings Schema Version 1.0-macosx
+ *  Sun xVM VirtualBox Settings Schema Version 1.0-macosx
 
      Copyright (C) 2004-2008 Sun Microsystems, Inc.
@@ -31,6 +31,6 @@
 <xsd:annotation>
   <xsd:documentation xml:lang="en">
-    innotek VirtualBox Settings Schema (macosx).
-    Copyright (c) 2004-2008 innotek GmbH.
+    Sun xVM VirtualBox Settings Schema (macosx).
+    Copyright (c) 2004-2008 Sun Microsystems, Inc.
   </xsd:documentation>
 </xsd:annotation>
Index: /trunk/src/VBox/Main/xml/VirtualBox-settings-os2.xsd
===================================================================
--- /trunk/src/VBox/Main/xml/VirtualBox-settings-os2.xsd	(revision 8202)
+++ /trunk/src/VBox/Main/xml/VirtualBox-settings-os2.xsd	(revision 8203)
@@ -4,5 +4,5 @@
  *  :folding=explicit:collapseFolds=1:
  *
- *  innotek VirtualBox Settings Schema Version 1.0-os2
+ *  Sun xVM VirtualBox Settings Schema Version 1.0-os2
  *
      Copyright (C) 2004-2008 Sun Microsystems, Inc.
@@ -31,6 +31,6 @@
 <xsd:annotation>
   <xsd:documentation xml:lang="en">
-    innotek VirtualBox Settings Schema (os2).
-    Copyright (c) 2004-2008 innotek GmbH.
+    Sun xVM VirtualBox Settings Schema (os2).
+    Copyright (c) 2004-2008 Sun Microsystems, Inc.
   </xsd:documentation>
 </xsd:annotation>
Index: /trunk/src/VBox/Main/xml/VirtualBox-settings-solaris.xsd
===================================================================
--- /trunk/src/VBox/Main/xml/VirtualBox-settings-solaris.xsd	(revision 8202)
+++ /trunk/src/VBox/Main/xml/VirtualBox-settings-solaris.xsd	(revision 8203)
@@ -4,5 +4,5 @@
  *  :folding=explicit:collapseFolds=1:
  *
- *  innotek VirtualBox Settings Schema Version 1.0-solaris
+ *  Sun xVM VirtualBox Settings Schema Version 1.0-solaris
 
      Copyright (C) 2004-2008 Sun Microsystems, Inc.
@@ -31,6 +31,6 @@
 <xsd:annotation>
   <xsd:documentation xml:lang="en">
-    innotek VirtualBox Settings Schema (solaris).
-    Copyright (c) 2004-2008 innotek GmbH.
+    Sun xVM VirtualBox Settings Schema (solaris).
+    Copyright (c) 2004-2008 Sun Microsystems, Inc.
   </xsd:documentation>
 </xsd:annotation>
Index: /trunk/src/VBox/Main/xml/VirtualBox-settings-windows.xsd
===================================================================
--- /trunk/src/VBox/Main/xml/VirtualBox-settings-windows.xsd	(revision 8202)
+++ /trunk/src/VBox/Main/xml/VirtualBox-settings-windows.xsd	(revision 8203)
@@ -4,5 +4,5 @@
  *  :folding=explicit:collapseFolds=1:
  *
- *  innotek VirtualBox Settings Schema Version 1.0-windows
+ *  Sun xVM VirtualBox Settings Schema Version 1.0-windows
 
      Copyright (C) 2004-2008 Sun Microsystems, Inc.
@@ -31,6 +31,6 @@
 <xsd:annotation>
   <xsd:documentation xml:lang="en">
-    innotek VirtualBox Settings Schema (windows).
-    Copyright (c) 2004-2008 innotek GmbH.
+    Sun xVM VirtualBox Settings Schema (windows).
+    Copyright (c) 2004-2008 Sun Microsystems, Inc.
   </xsd:documentation>
 </xsd:annotation>
Index: /trunk/src/VBox/Main/xml/samples/VirtualBox-global.xml
===================================================================
--- /trunk/src/VBox/Main/xml/samples/VirtualBox-global.xml	(revision 8202)
+++ /trunk/src/VBox/Main/xml/samples/VirtualBox-global.xml	(revision 8203)
@@ -1,4 +1,4 @@
 <?xml version="1.0" encoding="UTF-8" standalone="no" ?>
-<!-- innotek VirtualBox Sample Global Configuration -->
+<!-- Sun xVM VirtualBox Sample Global Configuration -->
 <!--
  *  :tabSize=2:indentSize=2:noTabs=true:
Index: /trunk/src/VBox/Main/xml/samples/VirtualBox-machine-linux.xml
===================================================================
--- /trunk/src/VBox/Main/xml/samples/VirtualBox-machine-linux.xml	(revision 8202)
+++ /trunk/src/VBox/Main/xml/samples/VirtualBox-machine-linux.xml	(revision 8203)
@@ -1,4 +1,4 @@
 <?xml version="1.0" encoding="UTF-8" standalone="no" ?>
-<!-- innotek VirtualBox Sample Machine Configuration (for a linux host) -->
+<!-- Sun xVM VirtualBox Sample Machine Configuration (for a linux host) -->
 <!--
  *  :tabSize=2:indentSize=2:noTabs=true:
Index: /trunk/src/VBox/Main/xml/samples/VirtualBox-machine-windows.xml
===================================================================
--- /trunk/src/VBox/Main/xml/samples/VirtualBox-machine-windows.xml	(revision 8202)
+++ /trunk/src/VBox/Main/xml/samples/VirtualBox-machine-windows.xml	(revision 8203)
@@ -1,4 +1,4 @@
 <?xml version="1.0" encoding="UTF-8" standalone="no" ?>
-<!-- innotek VirtualBox Sample Machine Configuration (for a win32 host) -->
+<!-- Sun xVM VirtualBox Sample Machine Configuration (for a win32 host) -->
 <!--
  *  :tabSize=2:indentSize=2:noTabs=true: