Index: trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitClear.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitClear.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitClear.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMAtomicBitClear().
+; IPRT - ASMAtomicBitClear().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitTestAndToggle.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitTestAndToggle.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitTestAndToggle.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMAtomicBitTestAndToggle().
+; IPRT - ASMAtomicBitTestAndToggle().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitToggle.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitToggle.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMAtomicBitToggle.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMAtomicBitToggle().
+; IPRT - ASMAtomicBitToggle().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMAtomicReadU64.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMAtomicReadU64.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMAtomicReadU64.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMAtomicReadU64().
+; IPRT - ASMAtomicReadU64().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMAtomicXchgU16.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMAtomicXchgU16.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMAtomicXchgU16.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMAtomicXchgU16().
+; IPRT - ASMAtomicXchgU16().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMAtomicXchgU8.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMAtomicXchgU8.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMAtomicXchgU8.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMAtomicXchgU8().
+; IPRT - ASMAtomicXchgU8().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMBitFirstClear.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMBitFirstClear.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMBitFirstClear.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMBitFirstClear().
+; IPRT - ASMBitFirstClear().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMBitFirstSet.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMBitFirstSet.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMBitFirstSet.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMBitFirstSet().
+; IPRT - ASMBitFirstSet().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetCS.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetCS.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetCS.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetCS().
+; IPRT - ASMGetCS().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetDR0.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetDR0.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetDR0.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetDR0().
+; IPRT - ASMGetDR0().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetDR1.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetDR1.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetDR1.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetDR1().
+; IPRT - ASMGetDR1().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetDR2.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetDR2.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetDR2.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetDR2().
+; IPRT - ASMGetDR2().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetDR3.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetDR3.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetDR3.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetDR3().
+; IPRT - ASMGetDR3().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetDR6.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetDR6.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetDR6.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetDR6().
+; IPRT - ASMGetDR6().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetDR7.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetDR7.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetDR7.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetDR7().
+; IPRT - ASMGetDR7().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetDS.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetDS.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetDS.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetDS().
+; IPRT - ASMGetDS().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetES.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetES.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetES.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetES().
+; IPRT - ASMGetES().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetFS.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetFS.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetFS.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetFS().
+; IPRT - ASMGetFS().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetFlags.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetFlags.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetFlags.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetFlags().
+; IPRT - ASMGetFlags().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetGDTR.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetGDTR.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetGDTR.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetGDTR().
+; IPRT - ASMGetGDTR().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetGS.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetGS.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetGS.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetGS().
+; IPRT - ASMGetGS().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetIDTR.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetIDTR.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetIDTR.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetIDTR().
+; IPRT - ASMGetIDTR().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetSS.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetSS.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetSS.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetSS().
+; IPRT - ASMGetSS().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMGetTR.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMGetTR.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMGetTR.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMGetTR().
+; IPRT - ASMGetTR().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMProbeReadByte.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMProbeReadByte.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMProbeReadByte.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMProbeReadByte().
+; IPRT - ASMProbeReadByte().
 ;
 
Index: trunk/src/VBox/Runtime/win/amd64/ASMSetFlags.asm
===================================================================
--- trunk/src/VBox/Runtime/win/amd64/ASMSetFlags.asm	(revision 8254)
+++ trunk/src/VBox/Runtime/win/amd64/ASMSetFlags.asm	(revision 8255)
@@ -1,4 +1,4 @@
 ;; @file
-; innotek Portable Runtime - ASMSetFlags().
+; IPRT - ASMSetFlags().
 ;
 