Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-solaris.c
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-solaris.c	(revision 8328)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-solaris.c	(revision 8351)
@@ -35,5 +35,4 @@
 
 #include "VBoxGuestInternal.h"
-#include <VBox/VBoxDev.h>       /* for VMMDEV_GUEST_SUPPORTS_GRAPHICS */
 #include <VBox/log.h>
 #include <iprt/assert.h>
@@ -332,24 +331,15 @@
                                     if (RT_SUCCESS(rc))
                                     {
-                                        /*
-                                         * Disable graphics capability explicitly for Solaris guests.
-                                         */
-                                        rc = VBoxGuestSetGuestCapabilities(0, VMMDEV_GUEST_SUPPORTS_GRAPHICS);
-                                        if (RT_SUCCESS(rc))
+                                        rc = ddi_create_minor_node(pDip, DEVICE_NAME, S_IFCHR, instance, DDI_PSEUDO, 0);
+                                        if (rc == DDI_SUCCESS)
                                         {
-                                            rc = ddi_create_minor_node(pDip, DEVICE_NAME, S_IFCHR, instance, DDI_PSEUDO, 0);
-                                            if (rc == DDI_SUCCESS)
-                                            {
-                                                g_pDip = pDip;
-                                                ddi_set_driver_private(pDip, pState);
-                                                pci_config_teardown(&PciHandle);
-                                                ddi_report_dev(pDip);
-                                                return DDI_SUCCESS;
-                                            }
-
-                                            LogRel((DEVICE_NAME ":ddi_create_minor_node failed.\n"));
+                                            g_pDip = pDip;
+                                            ddi_set_driver_private(pDip, pState);
+                                            pci_config_teardown(&PciHandle);
+                                            ddi_report_dev(pDip);
+                                            return DDI_SUCCESS;
                                         }
-                                        else
-                                            LogRel((DEVICE_NAME ":VBoxGuestSetGuestCapabilities failed. rc=%d\n", rc));
+
+                                        LogRel((DEVICE_NAME ":ddi_create_minor_node failed.\n"));
                                     }
                                     else
@@ -499,5 +489,5 @@
 
     /*
-     * Verify we are being opened as a character device
+     * Verify we are being opened as a character device.
      */
     if (fType != OTYP_CHR)
Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp	(revision 8328)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp	(revision 8351)
@@ -220,7 +220,15 @@
                 if (RT_SUCCESS(rc))
                 {
-                    vboxGuestInitFixateGuestMappings(pDevExt);
-                    Log(("VBoxGuestInitDevExt: returns success\n"));
-                    return VINF_SUCCESS;
+                    /*
+                     * Disable guest graphics capability by default. The guest specific
+                     * graphics driver will re-enable this when it is necessary.
+                     */
+                    rc = VBoxGuestSetGuestCapabilities(0, VMMDEV_GUEST_SUPPORTS_GRAPHICS);
+                    if (RT_SUCCESS(rc))
+                    {
+                        vboxGuestInitFixateGuestMappings(pDevExt);
+                        Log(("VBoxGuestInitDevExt: returns success\n"));
+                        return VINF_SUCCESS;
+                    }
                 }
             }