Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 8466)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 8467)
@@ -49,4 +49,6 @@
 ifdef VBOX_OSE
 VirtualBox_QT_IMAGES += \
+	images/OSE/about.png \
+	images/OSE/about_tile.png \
 	images/OSE/about_16px.png \
 	images/OSE/VirtualBox_16px.png \
@@ -57,14 +59,15 @@
 	images/OSE/VirtualBox_64px.png \
 	images/OSE/VirtualBox_cube_42px.png
-eelse
+else
 VirtualBox_QT_IMAGES += \
-	images/about_16px.png \
-	images/VirtualBox_16px.png \
-	images/VirtualBox_20px.png \
-	images/VirtualBox_32px.png \
-	images/VirtualBox_40px.png \
-	images/VirtualBox_48px.png \
-	images/VirtualBox_64px.png \
-	images/VirtualBox_cube_42px.png
+	images/NonOSE/about.png \
+	images/NonOSE/about_16px.png \
+	images/NonOSE/VirtualBox_16px.png \
+	images/NonOSE/VirtualBox_20px.png \
+	images/NonOSE/VirtualBox_32px.png \
+	images/NonOSE/VirtualBox_40px.png \
+	images/NonOSE/VirtualBox_48px.png \
+	images/NonOSE/VirtualBox_64px.png \
+	images/NonOSE/VirtualBox_cube_42px.png
 endif
 
@@ -303,5 +306,4 @@
 
 ifndef VBOX_OSE
-VirtualBox_QT_IMAGES += images/about_sun.png
 VirtualBox_SOURCES += src/VBoxAboutNonOSEDlg.cpp
 VirtualBox_QT_MOCHDRS += include/VBoxAboutNonOSEDlg.h
@@ -433,5 +435,5 @@
 else
 VirtualBox.app_SOURCES += \
-	images/VirtualBox.icns=>Resources/virtualbox.icns
+	images/NonOSE/VirtualBox.icns=>Resources/virtualbox.icns
 endif
 
@@ -457,5 +459,5 @@
 else
 VirtualBoxVM.app_SOURCES += \
-	images/VirtualBox.icns=>Resources/virtualbox.icns
+	images/NonOSE/VirtualBox.icns=>Resources/virtualbox.icns
 endif
 VirtualBoxVM.app_SYMLINKS = \
Index: trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 8466)
+++ trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 8467)
@@ -281,6 +281,4 @@
 	images/meditation_32px.png \
 	images/welcome.png \
-	images/about.png \
-	images/about_tile.png \
 	images/dock_1.png
 
Index: trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk	(revision 8466)
+++ trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk	(revision 8467)
@@ -662,5 +662,5 @@
 else
 VirtualBox.app_SOURCES += \
-	images/VirtualBox.icns=>Resources/virtualbox.icns
+	images/NonOSE/VirtualBox.icns=>Resources/virtualbox.icns
 endif
 
@@ -686,5 +686,5 @@
 else
 VirtualBoxVM.app_SOURCES += \
-	images/VirtualBox.icns=>Resources/virtualbox.icns
+	images/NonOSE/VirtualBox.icns=>Resources/virtualbox.icns
 endif
 VirtualBoxVM.app_SYMLINKS = \
@@ -732,8 +732,8 @@
 # resource files exists.
 ifdef VBOX_OSE
-VirtualBox_QT_RC_OSE += $(shell $(SED) '/images/!d;{s/^.*\(images\/.*\)<.*$$/\1/}' VirtualBoxOSE.qrc)
+VirtualBox_QT_RC_OSE += $(shell $(SED) '/images/!d;{s/^.*\(images\/.*\)<.*$$/\1/}' VirtualBox_OSE.qrc)
 VirtualBox_GENSRCS += $(PATH_VirtualBox)/ui/qrc_application_ose.cpp
 else
-VirtualBox_QT_RC_NON_OSE += $(shell $(SED) '/images/!d;{s/^.*\(images\/.*\)<.*$$/\1/}' VirtualBoxNonOSE.qrc)
+VirtualBox_QT_RC_NON_OSE += $(shell $(SED) '/images/!d;{s/^.*\(images\/.*\)<.*$$/\1/}' VirtualBox_NonOSE.qrc)
 VirtualBox_GENSRCS += $(PATH_VirtualBox)/ui/qrc_application_non_ose.cpp
 VirtualBox_SOURCES += src/VBoxAboutNonOSEDlg.cpp
@@ -951,9 +951,9 @@
 	$(QUIET)$(VBOX_RCC4) -o $@  $<
 
-$(PATH_VirtualBox)/ui/qrc_application_ose.cpp: VirtualBoxOSE.qrc $(VirtualBox_QT_RC_OSE)
+$(PATH_VirtualBox)/ui/qrc_application_ose.cpp: VirtualBox_OSE.qrc $(VirtualBox_QT_RC_OSE)
 	$(call MSG_TOOL,rcc,VirtualBox,$<,$@)
 	$(QUIET)$(VBOX_RCC4) -name "OSE" -o $@  $<
 
-$(PATH_VirtualBox)/ui/qrc_application_non_ose.cpp: VirtualBoxNonOSE.qrc $(VirtualBox_QT_RC_NON_OSE)
+$(PATH_VirtualBox)/ui/qrc_application_non_ose.cpp: VirtualBox_NonOSE.qrc $(VirtualBox_QT_RC_NON_OSE)
 	$(call MSG_TOOL,rcc,VirtualBox,$<,$@)
 	$(QUIET)$(VBOX_RCC4) -name "NonOSE" -o $@  $<
Index: trunk/src/VBox/Frontends/VirtualBox4/VirtualBoxOSE.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/VirtualBoxOSE.qrc	(revision 8466)
+++ 	(revision )
@@ -1,14 +1,0 @@
-<!DOCTYPE RCC><RCC version="1.0">
- <qresource prefix="/">
-    <file alias="about.png">images/about.png</file>
-    <file alias="about_tile.png">images/about_tile.png</file>
-    <file alias="VirtualBox_16px.png">images/OSE/VirtualBox_16px.png</file>
-    <file alias="VirtualBox_20px.png">images/OSE/VirtualBox_20px.png</file>
-    <file alias="VirtualBox_32px.png">images/OSE/VirtualBox_32px.png</file>
-    <file alias="VirtualBox_40px.png">images/OSE/VirtualBox_40px.png</file>
-    <file alias="VirtualBox_48px.png">images/OSE/VirtualBox_48px.png</file>
-    <file alias="VirtualBox_64px.png">images/OSE/VirtualBox_64px.png</file>
-    <file alias="VirtualBox_cube_42px.png">images/OSE/VirtualBox_cube_42px.png</file>
-    <file alias="about_16px.png">images/OSE/about_16px.png</file>
- </qresource>
- </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox4/VirtualBox_OSE.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/VirtualBox_OSE.qrc	(revision 8467)
+++ trunk/src/VBox/Frontends/VirtualBox4/VirtualBox_OSE.qrc	(revision 8467)
@@ -0,0 +1,14 @@
+<!DOCTYPE RCC><RCC version="1.0">
+ <qresource prefix="/">
+    <file alias="about.png">images/about.png</file>
+    <file alias="about_tile.png">images/about_tile.png</file>
+    <file alias="VirtualBox_16px.png">images/OSE/VirtualBox_16px.png</file>
+    <file alias="VirtualBox_20px.png">images/OSE/VirtualBox_20px.png</file>
+    <file alias="VirtualBox_32px.png">images/OSE/VirtualBox_32px.png</file>
+    <file alias="VirtualBox_40px.png">images/OSE/VirtualBox_40px.png</file>
+    <file alias="VirtualBox_48px.png">images/OSE/VirtualBox_48px.png</file>
+    <file alias="VirtualBox_64px.png">images/OSE/VirtualBox_64px.png</file>
+    <file alias="VirtualBox_cube_42px.png">images/OSE/VirtualBox_cube_42px.png</file>
+    <file alias="about_16px.png">images/OSE/about_16px.png</file>
+ </qresource>
+ </RCC>